#!/usr/bin/env python  
# -*- coding: utf-8 -*-    
#
#       addPrincipalStressWithDialog.py
#
#       データに主応力を追加する
#
#   使い方
#   addPrincipalStressWithDialog <detaFile名>
#       dataFile名   :wildCardで指定する
#                     currentDir内のfileを指定する（重要）
#
#   15/06/19    新規作成
#      09/01    windows対応として、os.sepに変更
#      09/02    "\n"→os.linesepに修正
#
#

import sys
import os
import pygtk
pygtk.require("2.0")
import gtk
import glob
import pyFistr


addFileName = ""
ls = os.linesep         #行末コード

class windowApp:  
    def __init__(self):
        error = addPrincipalStress()
        if error == "":
            title = _(u"データ変換")
            mess = _(u"結果データに主応力を追加しました。")
            self.okDialog(title, mess)
        elif error == "noFile":
            title = _(u"エラー")
            mess = _(u"結果データがparaView用に変換されていません。") + ls
            mess += _(u"データ変換後、主応力を追加してください。")
            self.errDialog(title, mess)
        elif error == "added":
            title = _(u"エラー")
            mess = _(u"既に主応力が追加されています。") + ls
            self.errDialog(title, mess)
        elif error == "noStress":
            title = _(u"エラー")
            mess = _(u"NodalSTRESSが出力されていないため、主応力が計算できません。")
            self.errDialog(title, mess)


    def okDialog(self, title, message):
        dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, buttons=gtk.BUTTONS_OK)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()

    def errDialog(self, title, message):
        dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK)
        dlg.set_title(title)
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()



def addPrincipalStress():
    files = glob.glob("convFistrModel.res*.vtk")
    if len(files) == 0:
        error = "noFile"
        return error

    #主応力を追加
    print
    print _(u"主応力を結果に追加します")
    steps = []
    nameHeader = ".".join(files[0].split(".")[:-2])
    for fileName in files:
        name = fileName
        step = name.split(".")[-2]
        steps.append(int(step))
    steps.sort()
    names = []
    i = 0
    for fileName in files:
        name = nameHeader+ "." + str(steps[i]) + ".vtk"
        names.append(name)
        i += 1

    error = ""
    for fileName in names:
        #name = fileName.split("/")[-1]
        name = fileName.split(os.sep)[-1]
        print name + _(u" 主応力データ追加中...")
        f=open(fileName); lines=f.readlines(); f.close()
        if pyFistr.isPrincipalStressInVtk(lines) == True:
            error = "added"
            break
        if pyFistr.isNodalStressInVtk(lines) == False:
            error = "noStress"
            break
        lines = pyFistr.addPrincipalStressDataInVtk(lines)
        f=open(fileName, "w")
        for line in lines:
            f.write(line)
        f.close()
    if error == "":
        print _(u"主応力を追加しました。")
    return error



if __name__ == "__main__":  
    import gettext
    gettext.install("app") # replace with the appropriate catalog name

    addFileName = sys.argv[1]

    windowApp()  




